<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/base/icecap-failure/src/error.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>error.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../icecap_failure/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../icecap_failure/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../icecap_failure/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">alloc::boxed::Box</span>;
<span class="kw">use</span> <span class="ident">core::any::TypeId</span>;
<span class="kw">use</span> <span class="ident">core::fmt</span>::{<span class="self">self</span>, <span class="ident">Debug</span>, <span class="ident">Display</span>};

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::backtrace::Backtrace</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::context::Context</span>;
<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">Causes</span>, <span class="ident">Fail</span>};

<span class="doccomment">/// The `Error` type, which can contain any failure.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Functions which accumulate many kinds of errors should return this type.</span>
<span class="doccomment">/// All failures can be converted into it, so functions which catch those</span>
<span class="doccomment">/// errors can be tried with `?` inside of a function that returns this kind</span>
<span class="doccomment">/// of error.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// In addition to implementing `Debug` and `Display`, this type carries `Backtrace`</span>
<span class="doccomment">/// information, and can be downcast into the failure that underlies it for</span>
<span class="doccomment">/// more detailed inspection.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Error</span> {
    <span class="ident">inner</span>: <span class="ident">Box</span><span class="op">&lt;</span><span class="ident">Inner</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Fail</span><span class="op">&gt;</span><span class="op">&gt;</span>,
}

<span class="kw">struct</span> <span class="ident">Inner</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="question-mark">?</span><span class="ident">Sized</span> <span class="op">+</span> <span class="ident">Fail</span><span class="op">&gt;</span> {
    <span class="ident">backtrace</span>: <span class="ident">Backtrace</span>,
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="ident">failure</span>: <span class="ident">F</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">Fail</span><span class="op">&gt;</span> <span class="ident">From</span><span class="op">&lt;</span><span class="ident">F</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">from</span>(<span class="ident">failure</span>: <span class="ident">F</span>) -&gt; <span class="self">Self</span> {
        <span class="kw">let</span> <span class="ident">backtrace</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">failure</span>.<span class="ident">backtrace</span>() {
            <span class="prelude-val">None</span> =&gt; <span class="ident">Backtrace::new</span>(),
            <span class="prelude-val">Some</span>(<span class="kw">_</span>) =&gt; <span class="ident">Backtrace::none</span>(),
        };
        <span class="self">Self</span> {
            <span class="ident">inner</span>: <span class="ident">Box::new</span>(<span class="ident">Inner</span> { <span class="ident">failure</span>, <span class="ident">backtrace</span> }),
        }
    }
}

<span class="kw">impl</span> <span class="ident">Error</span> {
    <span class="doccomment">/// Return a reference to the underlying failure that this `Error`</span>
    <span class="doccomment">/// contains.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">as_fail</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="kw">dyn</span> <span class="ident">Fail</span> {
        <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">failure</span>
    }

    <span class="doccomment">/// Returns the name of the underlying fail.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">name</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">str</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">as_fail</span>().<span class="ident">name</span>()
    }

    <span class="doccomment">/// Gets a reference to the `Backtrace` for this `Error`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If the failure this wrapped carried a backtrace, that backtrace will</span>
    <span class="doccomment">/// be returned. Otherwise, the backtrace will have been constructed at</span>
    <span class="doccomment">/// the point that failure was cast into the `Error` type.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">backtrace</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="ident">Backtrace</span> {
        <span class="self">self</span>.<span class="ident">as_fail</span>().<span class="ident">backtrace</span>().<span class="ident">unwrap_or</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">backtrace</span>)
    }

    <span class="doccomment">/// Provides context for this `Error`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This can provide additional information about this error, appropriate</span>
    <span class="doccomment">/// to the semantics of the current layer. That is, if you have a</span>
    <span class="doccomment">/// lower-level error, such as an IO error, you can provide additional context</span>
    <span class="doccomment">/// about what that error means in the context of your function. This</span>
    <span class="doccomment">/// gives users of this function more information about what has gone</span>
    <span class="doccomment">/// wrong.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This takes any type that implements `Display`, as well as</span>
    <span class="doccomment">/// `Send`/`Sync`/`&#39;static`. In practice, this means it can take a `String`</span>
    <span class="doccomment">/// or a string literal, or a failure, or some other custom context-carrying</span>
    <span class="doccomment">/// type.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">context</span><span class="op">&lt;</span><span class="ident">D</span>: <span class="ident">Display</span> <span class="op">+</span> <span class="ident">Send</span> <span class="op">+</span> <span class="ident">Sync</span> <span class="op">+</span> <span class="lifetime">&#39;static</span><span class="op">&gt;</span>(<span class="self">self</span>, <span class="ident">context</span>: <span class="ident">D</span>) -&gt; <span class="ident">Context</span><span class="op">&lt;</span><span class="ident">D</span><span class="op">&gt;</span> {
        <span class="ident">Context::with_err</span>(<span class="ident">context</span>, <span class="self">self</span>)
    }

    <span class="doccomment">/// Attempts to downcast this `Error` to a particular `Fail` type.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This downcasts by value, returning an owned `T` if the underlying</span>
    <span class="doccomment">/// failure is of the type `T`. For this reason it returns a `Result` - in</span>
    <span class="doccomment">/// the case that the underlying error is of a different type, the</span>
    <span class="doccomment">/// original `Error` is returned.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">downcast</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Fail</span><span class="op">&gt;</span>(<span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span>, <span class="ident">Error</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">as_fail</span>().<span class="ident">__private_get_type_id__</span>() <span class="op">==</span> <span class="ident">TypeId::of</span>::<span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>() {
            <span class="prelude-val">Ok</span>(<span class="kw">unsafe</span> { <span class="ident">Box::from_raw</span>(<span class="ident">Box::into_raw</span>(<span class="self">self</span>.<span class="ident">inner</span>) <span class="kw">as</span> <span class="kw-2">*mut</span> <span class="ident">Inner</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>) }.<span class="ident">failure</span>)
        } <span class="kw">else</span> {
            <span class="prelude-val">Err</span>(<span class="self">self</span>)
        }
    }

    <span class="doccomment">/// Returns the &quot;root cause&quot; of this error - the last value in the</span>
    <span class="doccomment">/// cause chain which does not return an underlying `cause`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">find_root_cause</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="kw">dyn</span> <span class="ident">Fail</span> {
        <span class="self">self</span>.<span class="ident">as_fail</span>().<span class="ident">find_root_cause</span>()
    }

    <span class="doccomment">/// Returns a iterator over the causes of this error with the cause</span>
    <span class="doccomment">/// of the fail as the first item and the `root_cause` as the final item.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Use `iter_chain` to also include the fail of this error itself.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">iter_causes</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Causes</span> {
        <span class="self">self</span>.<span class="ident">as_fail</span>().<span class="ident">iter_causes</span>()
    }

    <span class="doccomment">/// Returns a iterator over all fails up the chain from the current</span>
    <span class="doccomment">/// as the first item up to the `root_cause` as the final item.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This means that the chain also includes the fail itself which</span>
    <span class="doccomment">/// means that it does *not* start with `cause`.  To skip the outermost</span>
    <span class="doccomment">/// fail use `iter_causes` instead.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">iter_chain</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="ident">Causes</span> {
        <span class="self">self</span>.<span class="ident">as_fail</span>().<span class="ident">iter_chain</span>()
    }

    <span class="doccomment">/// Attempts to downcast this `Error` to a particular `Fail` type by</span>
    <span class="doccomment">/// reference.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If the underlying error is not of type `T`, this will return `None`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">downcast_ref</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Fail</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;</span><span class="ident">T</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">as_fail</span>().<span class="ident">downcast_ref</span>()
    }

    <span class="doccomment">/// Attempts to downcast this `Error` to a particular `Fail` type by</span>
    <span class="doccomment">/// mutable reference.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If the underlying error is not of type `T`, this will return `None`.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">downcast_mut</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Fail</span><span class="op">&gt;</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="kw-2">&amp;mut</span> <span class="ident">T</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">failure</span>.<span class="ident">downcast_mut</span>()
    }
}

<span class="kw">impl</span> <span class="ident">Display</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">Display::fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">failure</span>, <span class="ident">f</span>)<span class="question-mark">?</span>;
        <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">not</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;postcard&quot;</span>), <span class="ident">allow</span>(<span class="ident">unused_variables</span>))]</span>
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">backtrace</span>) <span class="op">=</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">inner</span>.<span class="ident">backtrace</span>.<span class="ident">inner</span> {
            <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;postcard&quot;</span>)]</span>
            <span class="macro">write!</span>(
                <span class="ident">f</span>,
                <span class="string">&quot;\nstack backtrace for error:\n\n    {}\n&quot;</span>,
                <span class="ident">backtrace</span>.<span class="ident">display_hex</span>()
            )<span class="question-mark">?</span>;
        }
        <span class="prelude-val">Ok</span>(())
    }
}

<span class="comment">// TODO</span>
<span class="kw">impl</span> <span class="ident">Debug</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">f</span>: <span class="kw-2">&amp;mut</span> <span class="ident">fmt::Formatter</span>) -&gt; <span class="ident">fmt::Result</span> {
        <span class="ident">Debug::fmt</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">as_fail</span>(), <span class="ident">f</span>)
    }
}

<span class="kw">impl</span> <span class="ident">AsRef</span><span class="op">&lt;</span><span class="kw">dyn</span> <span class="ident">Fail</span><span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">Error</span> {
    <span class="kw">fn</span> <span class="ident">as_ref</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) -&gt; <span class="kw-2">&amp;</span><span class="kw">dyn</span> <span class="ident">Fail</span> {
        <span class="self">self</span>.<span class="ident">as_fail</span>()
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="icecap_failure" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>